import { BrowserCondition, CollectionCondition, ElementCondition } from '../../conditions';
export declare namespace have {
    const no: typeof have;
    const exactText: (value: string | number) => ElementCondition;
    const text: (value: string | number | RegExp) => ElementCondition;
    const attribute: (name: string) => ElementCondition;
    const attributeWithValue: (attributeName: string, attributeValue: string | number) => ElementCondition;
    const attributeWithValueContaining: (attributeName: string, attributeValue: string | number) => ElementCondition;
    const value: (value: string | number) => ElementCondition;
    const valueContaining: (expected: string | number) => ElementCondition;
    const cssClass: (cssClass: string) => ElementCondition;
    const size: (size: number) => CollectionCondition;
    const sizeLessThan: (size: number) => CollectionCondition;
    const sizeLessThanOrEqual: (size: number) => CollectionCondition;
    const sizeGreaterThan: (size: number) => CollectionCondition;
    const sizeGreaterThanOrEqual: (size: number) => CollectionCondition;
    const texts: (...texts: string[]) => CollectionCondition;
    const exactTexts: (...texts: string[]) => CollectionCondition;
    const url: (url: string) => BrowserCondition;
    const urlContaining: (urlPart: string) => BrowserCondition;
    const title: (expected: string) => BrowserCondition;
    const titleContaining: (titlePart: string) => BrowserCondition;
    const tabsNumber: (num: number) => BrowserCondition;
    const tabsNumberLessThan: (num: number) => BrowserCondition;
    const tabsNumberMoreThan: (num: number) => BrowserCondition;
    const jsReturned: (expected: any, script: string, ...scriptArgs: any[]) => BrowserCondition;
}
